

compute_statistics <- function(recipe, data){
  
  # data$hcst: s2dv_cube containing the hindcast
  # obs: s2dv_cube containing the observations
  # recipe: auto-s2s recipe as provided by read_yaml
  
  
  statistics <- tolower(recipe$Analysis$Workflow$Statistics$metrics)
  
  data_statistics <- list()
  
  # ## remove ensemble dimension
  # obs_data <- adrop(data$obs$data, drop = 9)
  # ## Duplicate obs along hcst ensemble dimension
  # obs_data <- InsertDim(data = obs_data, pos = 9, lendim = 25, name = 'ensemble')
  
  for (stat in strsplit(statistics, ", | |,")[[1]]) {
    # Whether the fair version of the metric is to be computed
    if (stat %in% c('cov', 'covariance')) {
      
       ## Calculate variance = square of standard deviation
       var_hcst <- (Apply(data = data$hcst$data, target_dims = c('syear','ensemble'), fun = 'sd')$output1)^2
       var_obs <- (Apply(data = data$obs$data, target_dims = c('syear','ensemble'), fun = 'sd')$output1)^2
       
       ## calculate covariance
       covariance <- var_hcst ## Temporary solution - need to create empty array!!
       
       for(lat in 1:dim(data$hcst$data)['latitude']){
         for(lon in 1:dim(data$hcst$data)['longitude']){
           for(ft in 1:dim(data$hcst$data)['time']){
           covariance[,,,,ft,lat,lon] <-(var_hcst[,,,,ft,lat,lon] * var_obs[,,,,ft,lat, lon]) # / length(var_hcst[,,,,ft,lat,lon]) ??
           }
         }
       }
       data_statistics[[ stat ]] <- covariance
       
    } ## close if on cov
       
    
    if (stat %in% c('std', 'standard_deviation')) {
      
       ## Calculate standard deviation
       std_hcst <- Apply(data = data$hcst$data, target_dims = c('syear','ensemble'), fun = 'sd')$output1
       std_obs <- Apply(data = data$obs$data, target_dims = c('syear','ensemble'), fun = 'sd')$output1

       data_statistics[[ stat ]] <- list('std_hcst' = std_hcst, 'std_obs' = std_obs)
       
       
     } ## close if on std
  
  }
  
}  